package com.persagy.bdtp.adm.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.dmp.digital.entity.ObjectDigital;
import lombok.Data;

@Data
@TableName(value = "adm_object",autoResultMap = true)
public class AdmObject extends ObjectDigital {

	/** 创建对象的本地设备(移动端) */
	private String clientDevice;

	/** 由本地设备生成的对象id */
	private String clientId;

	/**  数模同步状态：0未同步, 1已同步 */
	private Integer d2mState;

	/** 交付BDTP状态:1已交付,0待交付 */
	private Integer deliveryState;

	private String buildingId;

	private String floorId;

	/** app端上传数据标记 */
	private String uploadFlag;

	public JsonNode getInfo(String infoCode){
		ObjectNode node = getInfos();
		if(node != null)
			return node.get(infoCode);
		return null;
	}

}
